<%--
*******************************************************************************
* Copyright (C) 2006 Ping Identity Corporation All rights reserved.
*
* This software is licensed under the Open Software License v2.1 (OSL v2.1).
*
* A copy of this license has been provided with the distribution of this
* software. Additionally, a copy of this license is available at:
* http://opensource.org/licenses/osl-2.1.php
*
******************************************************************************
--%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<%@ page import = "java.io.File" %>
<%@ page import = "java.io.IOException" %>
<%@ page import = "java.io.InputStream" %>
<%@ page import = "java.io.FileInputStream" %>
<%@ page import = "java.util.Calendar" %>
<%@ include file="src/global.jsp" %>

<%

	Calendar rightNow = Calendar.getInstance(); 

	System.out.println("UTC Time = " + rightNow.getTime());

     String userId = null;
     Map userInfo = (HashMap)session.getAttribute("userInfo"); //$NON-NLS-1$
     if((userInfo == null) || (userInfo.size() <= 0)) {
	   response.sendRedirect("login.jsp");
     }
     else {
        userId = (String)userInfo.get("userId");
     }
%>

<%
	loadGlobalProperties(config, request);

	String spHomeUrl   = getSpHomeUrl();
	String idpStartSLO = getIdpSLOLink();

	String errorMessage = "Error+during+idp-initiated+SLO";    //$NON-NLS-1$
	idpStartSLO = addIdpInErrorResource(idpStartSLO, errorMessage);

%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<title>Identity Provider Protected Page</title>
	<link rel="stylesheet" type="text/css" href="style.css">
	<script type="text/javascript" src="scripts/common.js"></script>
	<script language="javascript">
		function initiateSSO(url) {
			window.location = url;
		}
	</script>
</head>


<body>

    <center>
	<table class="mainidp">
		<tr>
			<td COLSPAN="2">
			<img src="images/products_pf_no_version.png">
			<h1 class="idp">Identity Provider Main Page</h1>
			<span class="description">This is the main page of the IdP Sample Application.<br>You can initiate Single Sign on to any of the configured SP connections or perform single logout.</span>
			<br><br>
			</td>
		</tr>
            <td align="center" class="rightbody" valign="top">

                        <%
						File connectionsFile = new File(connectionsFilePath);

						String connectionName = null;
						String connectionValue = null;
						String idpSSOUrl = null;
						String description = null;
						int count=0;
						String targetResource = null;


						if(connectionsFile.exists()) {
							Properties configProperties= getProperties(configFilePath);
							Properties connectionsProperties= getProperties(connectionsFilePath);		
	
	 						Enumeration connectionsPropertiesNames = connectionsProperties.propertyNames();
							while( connectionsPropertiesNames.hasMoreElements() ) {
								count++;
								connectionName  = (String)connectionsPropertiesNames.nextElement();
								connectionValue = connectionsProperties.getProperty(connectionName);	
	
								ArrayList connectionAttributes = getListValues(connectionValue);
								String partnerSpId = (String)connectionAttributes.get(0);
								targetResource = (String)connectionAttributes.get(1);
								String idpAdapterId = (String)connectionAttributes.get(2);
								description = (String)connectionAttributes.get(3);	
	
								// Get IdP Discovery mode
								String idpDiscovery = configProperties.getProperty("idpDiscovery");
	
									// If IdP Discovery is disabled do not send the IdP Adapter Id in the SSO request
								if( idpDiscovery.equalsIgnoreCase("true") ) {
									idpSSOUrl = getIdpStartSSOUrl(partnerSpId,targetResource,null,null);							
								}
								else {
									idpSSOUrl = getIdpStartSSOUrl(partnerSpId,targetResource,idpAdapterId,null,null);							
									}		
	
								errorMessage = "Error+during+SSO+to+" + connectionName;   //$NON-NLS-1$
								idpSSOUrl = addIdpInErrorResource(idpSSOUrl, errorMessage);
				%>

			   <table class="connection">
				   <tr>
					   <td>
						   <div class="headeridp">
							   SP Connection
							   <a href="javascript:openHelp('help.html?#sso');">
							   <img src="images/HelpIcon.gif" border="0">
							   </a>
						   </div>
					   </td>
				   </tr>
				   <tr>
					   <td align="left">
						   <span class="text"><strong>Connection Id: </strong><%= partnerSpId %></span>
					   </td>
				   </tr>
				   <tr>
					   <td align="left">
						   <span class="text"><strong>Description: </strong><%= description %></span>
					   </td>
				   </tr>
				   <tr>
					   <td>
							<a class="image" href="#">
								<img id="federate<%= count %>" name="federate<%= count %>" border="0" 
									src="images/Federate_Normal.gif" 
									OnMouseOver="javascript:document.all['federate<%= count %>'].src='images/Federate_Hover.gif';"
									OnMouseOut="javascript:document.all['federate<%= count %>'].src='images/Federate_Normal.gif';"
									OnClick="javascript:initiateSSO('<%= idpSSOUrl %>')">
							</a>
					   </td>
				   </tr>
				   <tr>
					   <td align="left">
						   <span class="text"><strong>Direct Link: </strong><a class="text" href="<%= targetResource %>"><%= targetResource %></a></span>
					   </td>
				   </tr>
			   </table>

                        <%
                        			}
						}
						else {
							setupSpList(request);
							List spList = (List)session.getAttribute(ATTRIB_NAME_SPLIST);
							Iterator spIterator = spList.iterator();
		
							while( spIterator.hasNext() ) {
								count++;
								connectionName = spIterator.next().toString();
								description = "Click on the image to initiate Single sign on";
								idpSSOUrl = getIdpStartSSOUrl(connectionName,null,null);		
				%>
			   <table class="connection">
				   <tr>
					   <td>
						   <div class="headeridp">
							   SP Connection
							   <a href="javascript:openHelp('help.html?#sso');">
							   <img src="images/HelpIcon.gif" border="0">
							   </a>
						   </div>
					   </td>
				   </tr>
				   <tr>
					   <td align="left">
						   <span class="text"><strong>Connection Id: </strong><%= connectionName %></span>
					   </td>
				   </tr>
						<tr>
							<td>
								<span class="text"><%= description %></span>
							</td>
						</tr>
				   <tr>
					   <td>
							<a class="image" href="#">
								<img id="federate<%= count %>" name="federate<%= count %>" border="0" 
									src="images/Federate_Normal.gif" 
									OnMouseOver="javascript:document.all['federate<%= count %>'].src='images/Federate_Hover.gif';"
									OnMouseOut="javascript:document.all['federate<%= count %>'].src='images/Federate_Normal.gif';"
									OnClick="javascript:initiateSSO('<%= idpSSOUrl %>')">
							</a>
					   </td>
				   </tr>
			   </table>

                        <%
                        			}
							// Check to see if any connections were obtained
							if(count == 0 ) {
				%>
								<script language="javascript">
								alert('Note that a connection supporting IdP initiated SSO should be configured before you can perform an SSO from the IdP application. Please configure such a connection and ensure that the PingFederate server is running.');
								</script>
				<%			
							}


						}


  				    %>


                        
          </td>
		<td align="center" class="rightbody" valign="top">
			<table class="sub">
				<tr>
					<td colspan="2">
						<div class="headeridp">
							User Attributes
							<a href="javascript:openHelp('help.html?#userattributes');">
								<img src="images/HelpIcon.gif" border="0">
							</a>
						</div>
					</td>
				</tr>

				<%
					if(userInfo != null && userInfo.size() > 0) {
						Set infoNames = userInfo.keySet();
						Iterator iterator = infoNames.iterator();
						while( iterator.hasNext() ) {
				%>
				<tr>
					<td align="left" width="100">
					<%
						String infoName = (String)iterator.next();
						String infoValue = (String)userInfo.get(infoName);

						if(infoName.equals(AUTHN_CTX_ATTRIBUTE_NAME)) {
							infoValue = displayAuthnContext(infoValue);
						}

						if(infoValue.length() > MAX_LENGTH) {
							infoValue = infoValue.substring(0,MAX_LENGTH);
							infoValue += "...";
						}
					%>
						<span class="text">
							<strong><%= infoName %></strong>
						</span>
					</td>
					<td align="left">
						<span class="text">
							<%= infoValue%>
						</span>
					</td>
				</tr>
				<%
						}
					}
				%>
			</table>
			<br>
			<table class="sub">
				<tr>
					<td>
						<div class="headeridp">
							Single Logout
							<a href="javascript:openHelp('help.html?#slo');">
								<img src="images/HelpIcon.gif" border="0">
							</a>
						</div>
					</td>
				</tr>
				<tr>
					<td>
						<span class="text">Click on the link for Single Logout</span>
					</td>
				</tr>
				<tr>
					<td>
						<a class="text" href="<%= idpStartSLO %>">Single Logout</a>
					</td>
				</tr>
			</table>
			<br>
			<table class="sub">
				<tr>
					<td>
						<div class="headeridp">
							Local Logout
							<a href="javascript:openHelp('help.html?#logout');">
								<img src="images/HelpIcon.gif" border="0">
							</a>
						</div>
					</td>
				</tr>
				<tr>
					<td>
						<span class="text">Click on the link for Local logout</span>
					</td>
				</tr>
				<tr>
					<td>
						<a class="text" href="/IdpSample/?cmd=logout">Local Logout</a>
					</td>
				</tr>
			</table>
			
		</td>
      </tr>
    </table>
      
      
      <br><br>
      
		<table width="500">
			<tr>
				<td align="center" style="font-size:10px;">
				<b>Related Links</b>
				<br>
				<a href="http://www.pingidentity.com/products/pingfederate">Overview</a> | <a href="http://www.pingidentity.com/products/federation_overview">About Federation</a> | <a href="http://www.pingidentity.com/products/integration">Integration</a>
				</td>
			</tr>
			<tr>
				<td class="version" style="text-align:center;">
					<a href="mailto:support@pingidentity.com">support@pingidentity.com</a> 
				</td>           
			</tr>
			<tr>
				<td class="version" style="text-align:center;">
					<a target="_new" href="http://www.pingidentity.com"><img src="images/ping_logo.gif" border="0"></a><br/><br/>
						&copy; 2003-2006 Ping Identity Corporation<br/>
						All Rights Reserved
				</td>
			</tr>
		</table>

    </center>
  </body>
</html>
