<!--
 *******************************************************************************
 * Copyright (C) 2006 Ping Identity Corporation All rights reserved.
 *
 * This software is licensed under the Open Software License v2.1 (OSL v2.1).
 *
 * A copy of this license has been provided with the distribution of this
 * software. Additionally, a copy of this license is available at:
 * http://opensource.org/licenses/osl-2.1.php
 *
 ******************************************************************************
 -->

<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>
<%@ page import = "java.io.File" %>
<%@ page import = "java.io.IOException" %>
<%@ page import = "java.io.InputStream" %>
<%@ page import = "java.io.FileInputStream" %>
<%@ include file="src/global.jsp" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<%
	loadGlobalProperties(config, request);

	String spSLOUrl   = getSpSLOLink();

	Properties configProperties = getProperties(configFilePath);

%>
     <%
		String userId = null;

		Map userInfo = (HashMap)session.getAttribute("userInfo");    //$NON-NLS-1$
		if((userInfo == null) || (userInfo.size() <= 0)) {
			String resumePath = request.getParameter("resumePath"); //$NON-NLS-1$
			String loginPage = getSpLoginPageUrl("main"); //$NON-NLS-1$

			if(resumePath != null) {
				loginPage = loginPage + "&resumePath=" + resumePath; //$NON-NLS-1$
			}
 	 		response.sendRedirect(loginPage);
		}
		else {
			userId = (String)userInfo.get("userId");  //$NON-NLS-1$
		}
     %>

<html>
  <head>
	<link rel="stylesheet" type="text/css" href="style.css">
	<title>Service Provider Main Page</title>
	<script type="text/javascript" src="scripts/common.js"></script>
	<script language="javascript">
		function initiateSSO(url,forceAuthn,isPassive) {
			if((document.all[forceAuthn].checked) && (document.all[isPassive].checked)) {
				alert("ForceAuthn and IsPassive cannot be checked at the same time");
			}
			else {
				if(document.all[forceAuthn].checked) {
					url += "&ForceAuthn=true";
				}
				if(document.all[isPassive].checked) {
					url += "&IsPassive=true";
				}
				window.location = url;
			}
		}
	</script>
  </head>
  <body>

    <center>
	<table class="mainsp">
		<tr>
			<td COLSPAN="2">
			<img src="images/products_pf_no_version.png">
			<h1 class="sp">Service Provider Main Page</h1>
			<span class="description">This is the main page of the SP Sample Application.<br>You can initiate Single Sign on to any of the configured IdP connections or perform single logout.</span>
			<br><br>
			</td>
		</tr>
            <td align="center" class="rightbody" valign="top">
						<%
							File connectionsFile = new File(connectionsFilePath);

							String connectionName = null;
							String connectionValue = null;
							String spSSOUrl = null;
							String description = null;
							int count=0;
								
							if(connectionsFile.exists()) {
								Properties connectionsProperties = getProperties(connectionsFilePath);
								Enumeration connectionsPropertiesNames = connectionsProperties.propertyNames();
								while( connectionsPropertiesNames.hasMoreElements() ) {
									count++;
								 	connectionName = (String)connectionsPropertiesNames.nextElement();
									connectionValue = connectionsProperties.getProperty(connectionName);	
			
									ArrayList connectionAttributes = getListValues(connectionValue);
									String partnerIdpId = (String)connectionAttributes.get(0);
									String spSessionAuthnAdapterId = (String)connectionAttributes.get(1);
									String idpApp = (String)connectionAttributes.get(2);
									description = (String)connectionAttributes.get(3);

									spSSOUrl = getSpStartSSOUrl(partnerIdpId,spSessionAuthnAdapterId,null,null);
									String errorMessage = "Error+during+SSO+to+" + connectionName;     //$NON-NLS-1$
									spSSOUrl = addSpInErrorResource(spSSOUrl, errorMessage);
  						   %>
					<table class="connection">
						<tr>
							<td colspan="2">
								<div class="headersp">
									IdP Connection
									<a href="javascript:openHelp('help.html?#sso');">
										<img src="images/HelpIcon.gif" border="0">
									</a>
								</div>
							</td>
						</tr>
						<tr>
							<td colspan="2" align="left">
								<span class="text"><strong>Connection Id: </strong><%= partnerIdpId %></span>
							</td>
						</tr>
						<tr>
							<td colspan="2" align="left">
								<span class="text"><strong>Description: </strong><%= description %></span>
							</td>
						</tr>
						<tr>
							<td align="center">
								<input type="checkbox" id="forceAuthn<%= count%>" name="forceAuthn<%= count%>">
									<span class="text">
										ForceAuthn
										<a href="javascript:openHelp('help.html?#forceAuthn');">
											<img src="images/HelpIcon.gif" border="0">
										</a>
									</span>
							</td>
							<td align="center">
								<input type="checkbox" id="isPassive<%= count%>" name="isPassive<%= count%>">
									<span class="text">
										IsPassive
										<a href="javascript:openHelp('help.html?#isPassive');">
											<img src="images/HelpIcon.gif" border="0">
										</a>
									</span>
							</td>
						</tr>

						<tr>
							<td colspan="2">
								<a class="image" href="#">
									<img id="federate<%= count %>" name="federate<%= count %>" border="0" 
										src="images/Federate_Normal.gif" 
										OnMouseOver="javascript:document.all['federate<%= count %>'].src='images/Federate_Hover.gif';"
										OnMouseOut="javascript:document.all['federate<%= count %>'].src='images/Federate_Normal.gif';"
										OnClick="javascript:initiateSSO('<%= spSSOUrl %>','forceAuthn<%= count%>','isPassive<%= count%>')">
								</a>
							</td>
						</tr>
						<tr>
							<td colspan="2" align="left">
								<span class="text"><strong>IdpApp: </strong><a class="text" href="<%= idpApp %>"><%= idpApp %></a></span>
							</td>
						</tr>
					</table>

			                  <%
				                     }
							}
							else {
								setupIdpList(request);
								List idpList = (List)session.getAttribute(ATTRIB_NAME_IDPLIST);
								Iterator idpIterator = idpList.iterator();
		
								while( idpIterator.hasNext() ) {
									count++;
									connectionName = idpIterator.next().toString();
									description = "Click on the image to initiate Single sign on";
									spSSOUrl = getSpStartSSOUrl(connectionName,null,null);		
						%>
					<table class="connection">
						<tr>
							<td colspan="2">
								<div class="headersp">
									IdP Connection
									<a href="javascript:openHelp('help.html?#sso');">
										<img src="images/HelpIcon.gif" border="0">
									</a>
								</div>
							</td>
						</tr>
						<tr>
							<td colspan="2" align="left">
								<span class="text"><strong>Connection Id: </strong><%= connectionName %></span>
							</td>
						</tr>
						<tr>
							<td colspan="2">
								<span class="text"><%= description %></span>
							</td>
						</tr>
						<tr>
							<td align="center">
								<input type="checkbox" id="forceAuthn<%= count%>" name="forceAuthn<%= count%>">
									<span class="text">
										ForceAuthn
										<a href="javascript:openHelp('help.html?#forceAuthn');">
											<img src="images/HelpIcon.gif" border="0">
										</a>
									</span>
							</td>
							<td align="center">
								<input type="checkbox" id="isPassive<%= count%>" name="isPassive<%= count%>">
									<span class="text">
										IsPassive
										<a href="javascript:openHelp('help.html?#isPassive');">
											<img src="images/HelpIcon.gif" border="0">
										</a>
									</span>
							</td>
						</tr>

						<tr>
							<td colspan="2">
								<a class="image" href="#">
									<img id="federate<%= count %>" name="federate<%= count %>" border="0" 
										src="images/Federate_Normal.gif" 
										OnMouseOver="javascript:document.all['federate<%= count %>'].src='images/Federate_Hover.gif';"
										OnMouseOut="javascript:document.all['federate<%= count %>'].src='images/Federate_Normal.gif';"
										OnClick="javascript:initiateSSO('<%= spSSOUrl %>','forceAuthn<%= count%>','isPassive<%= count%>')">
								</a>
							</td>
						</tr>
					</table>
						<%
								}
								// Check to see if any connections were obtained
								if(count == 0 ) {
						%>
										<script language="javascript">
										alert('Note that a connection supporting SP initiated SSO should be configured before you can perform an SSO from the SP application. Please configure such a connection and ensure that the PingFederate server is running.');
										</script>
						<%
								}

							}
						%>


          </td>
		<td align="center" class="rightbody" valign="top">
			<table class="sub">
				<tr>
					<td colspan="2">
						<div class="headersp">
							User Attributes
							<a href="javascript:openHelp('help.html?#userattributes');">
								<img src="images/HelpIcon.gif" border="0">
							</a>
						</div>
					</td>
				</tr>
					
					<%
						if(userInfo != null && userInfo.size() > 0) {
							Set infoNames = userInfo.keySet();
							Iterator iterator = infoNames.iterator();
							while( iterator.hasNext() ) {
					%>
				<tr>
					<td align="left" width="50">
					<%
						String infoName = (String)iterator.next();
						String infoValue = (String)userInfo.get(infoName);
						if(infoName.equals(AUTHN_CTX_ATTRIBUTE_NAME)) {
							infoValue = displayAuthnContext(infoValue);
						}
						if(infoValue.length() > MAX_LENGTH) {
							infoValue = infoValue.substring(0,MAX_LENGTH);
							infoValue += "...";
						}


					%>
						<span class="text">
							<strong><%= infoName %></strong>
						</span>
					</td>
					<td align="left">
						<span class="text">
							<%= infoValue%>
						</span>
					</td>
				</tr>
					<%
							}
						}
					%>

			</table>
			<br>
			<table class="sub">
				<tr>
					<td>
						<div class="headersp">
							Single Logout
							<a href="javascript:openHelp('help.html?#slo');">
								<img src="images/HelpIcon.gif" border="0">
							</a>
						</div>
					</td>
				</tr>
				<tr>
					<td>
						<span class="text">Click on the link for Single logout</span>
					</td>
				</tr>
				<tr>
					<td>
						<a class="text" href="<%= spSLOUrl %>">Single Logout</a>
					</td>
				</tr>
			</table>
			<br>
			<table class="sub">
				<tr>
					<td>
						<div class="headersp">
							Local Logout
							<a href="javascript:openHelp('help.html?#logout');">
								<img src="images/HelpIcon.gif" border="0">
							</a>
						</div>
					</td>
				</tr>
				<tr>
					<td>
						<span class="text">Click on the link for Local logout</span>
					</td>
				</tr>
				<tr>
					<td>
						<a class="text" href="/SpSample/?cmd=logout">Local Logout</a>
					</td>
				</tr>
			</table>
				<%
			   	//Show defederate link

				//get account mode: true, if it's account linking
				String linkingMode = configProperties.getProperty("accountLinking"); //$NON-NLS-1$

				//It is Account Linking mode. We can show link to defederate service
				if( linkingMode.equalsIgnoreCase("true") ) {  //$NON-NLS-1$
					//Get user session list
					ArrayList userSessionList = (ArrayList)session.
						getAttribute("userSessionID"); //$NON-NLS-1$

					if(userSessionList != null && userSessionList.size() > 0) {
						//Some sessions have been established via SSO.
						//We can activate defederate link.
						String spDefLink = getSpDefederateUrl();
				%>
					<br>
					<table class="sub">
						<tr>
							<td>
								<div class="headersp">
									De-federate
									<a href="javascript:openHelp('help.html?#defederate');">
										<img src="images/HelpIcon.gif" border="0">
									</a>
								</div>
							</td>
						</tr>
						<tr>
							<td>
								<span class="text">Click on the link to disassociate account link with the IdP</span>
							</td>
						</tr>
						<tr>
							<td>
								<a class="text" href="<%= spDefLink %>">De-federate</a>
							</td>
						</tr>
					</table>

				<%
					}
				}
				%>

		</td>
      </tr>
    </table>
      
		
			
      <br><br>
      
		<table width="500">
			<tr>
				<td align="center" style="font-size:10px;">
				<b>Related Links</b>
				<br>
				<a href="http://www.pingidentity.com/products/pingfederate">Overview</a> | <a href="http://www.pingidentity.com/products/federation_overview">About Federation</a> | <a href="http://www.pingidentity.com/products/integration">Integration</a>
				</td>
			</tr>
			<tr>
				<td class="version" style="text-align:center;">
					<a href="mailto:support@pingidentity.com">support@pingidentity.com</a> 
				</td>           
			</tr>
			<tr>
				<td class="version" style="text-align:center;">
					<a target="_new" href="http://www.pingidentity.com"><img src="images/ping_logo.gif" border="0"></a><br/><br/>
						&copy; 2003-2006 Ping Identity Corporation<br/>
						All Rights Reserved
				</td>
			</tr>
		</table>

    </center>
  </body>
</html>

